local amtrView = {};

DEFAULT_WIDTH = 158;
DEFAULT_HEIGHT = 64;

--local currentWidth = DEFAULT_WIDTH;
--local currentHeight = DEFAULT_HEIGHT;

local bombCounterFontSize = 8;
--local bombIcons = {};
--_, _, bombIcons[SPELL_LIVING_BOMB_ID] = GetSpellInfo(SPELL_LIVING_BOMB_ID);
--_, _, bombIcons[SPELL_NETHER_TEMPEST_ID] = GetSpellInfo(SPELL_NETHER_TEMPEST_ID);

-- VIEW --


-- Creates an object with the ui items for our icons.
function amtr.createWidget(name)
	local widget = getglobal("uiAmtrFrame" .. name);
	widget.icon = getglobal("uiAmtrFrame" .. name .. "Icon");
	widget.overlay = getglobal("uiAmtrFrame" .. name .. "Overlay");
	return widget;
end

-- set icon size
function amtr.setWidgetSize(widget, size)
	widget.icon:SetWidth(size/2);
	widget.icon:SetHeight(size/2);	-- Icon is double size, not sure how to handle that in the XML.
	widget.overlay:SetHeight(size);
	widget.overlay:SetWidth(size);
end

function amtr.setWidgetPos(widget, x, y)
	widget:SetPoint("TOPLEFT", x, y);
end

function amtr.setWidgetActive(widget, active)
	if (active) then
		widget.icon:SetAlpha(0.9);
		widget.overlay:SetAlpha(1);
	else
		widget.icon:SetAlpha(0.05);
		widget.overlay:SetAlpha(0.3);
	end
end


function amtr.createView() 

	-- Frame has to have a name for the position to be stored.
	amtrView.frame = uiAmtrFrame;
	amtr.frame = amtrView.frame; -- get rid of this!!


	amtr.frame:EnableMouse(true)	
	--amtrView.frame:SetFrameStrata("MEDIUM");

	amtrView.frame:SetPoint("CENTER");

	--[[
	amtrView.frame:SetMovable(true);
	amtrView.frame:SetResizable(true);
	amtrView.frame:RegisterForDrag("LeftButton");
	amtrView.frame:SetScript("OnDragStart", function(self) if (amtrConfig.lockWindow == false) then self:StartMoving() end end);
	amtrView.frame:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end);

	MyScriptOptionsButton:SetScript("OnMouseDown", function(self, button)
		onDragStart(amtrView.frame);
	end)

	MyScriptOptionsButton:SetScript("OnMouseUp", function(self, button)
		onDragStop(amtrView.frame);
	end)
	--]]
	
	amtrView.frame:SetScript("OnSizeChanged", onResize);

	amtrView.frame:SetMinResize(DEFAULT_WIDTH, DEFAULT_HEIGHT);
	
	--amtrView.igniteText = amtrView.frame:CreateFontString();

	amtrView.bombCounter = uiAmtrFrameBombCounter;--amtrView.frame:CreateFontString("hasteText", "OVERLAY");
	amtrView.powerTalentCounter = uiAmtrFramePowerTalentCounter;--amtrView.frame:CreateFontString("hasteText", "OVERLAY");
	

	--amtrView.critText = amtrView.frame:CreateFontString();

	-- We are reversing the status bar so bg is "foreground"
	amtrView.manaBar = amtrManaBar;--CreateFrame("StatusBar", nil, amtr.frame, "TextStatusBar");

	--print(" is this here? " .. arcArcaneChargeIcon);
	--:SetAlpha(0.5);
	amtrView.arcaneChargeIcons = {};
	
	amtrView.arcaneChargeIcons[0] = amtr.createWidget("Charge1");
	amtrView.arcaneChargeIcons[1] = amtr.createWidget("Charge2");
	amtrView.arcaneChargeIcons[2] = amtr.createWidget("Charge3");
	amtrView.arcaneChargeIcons[3] = amtr.createWidget("Charge4");

	-- Bomb and talent
	amtrView.bomb = amtr.createWidget("Bomb");
	amtrView.powerTalent = amtr.createWidget("PowerTalent");

end

-- Position elements in our frame. Called when we change layout settings.
function amtr.layoutView(bombSpellName, powerTalentSpellName)

	local width = math.floor(amtrView.frame:GetWidth());
	local height = math.floor(amtrView.frame:GetHeight());

	local wr = width/DEFAULT_WIDTH;	-- ratio
	local hr = height/DEFAULT_HEIGHT;

	-- Use all space available for charges and center them.

	-- Power talent pos and szie
	amtr.setWidgetPos(amtrView.powerTalent, 8*wr, -(25*hr));
	amtrView.powerTalent.icon:SetPoint("TOPLEFT", 1*wr, -(1*hr));
	amtrView.powerTalentCounter:SetPoint("CENTER", amtrView.powerTalent, "TOPLEFT", 11.5*wr, -(12*hr));
	amtr.setWidgetSize(amtrView.powerTalent, 38*wr, 38*hr);
	
	-- Bomb position
	amtr.setWidgetPos(amtrView.bomb, 31*wr, -(25*hr));
	amtrView.bomb.icon:SetPoint("TOPLEFT", 1*wr, -(1*hr));
	amtrView.bombCounter:SetPoint("CENTER", amtrView.bomb, "TOPLEFT", 11.5*wr, -(12*hr));
	amtr.setWidgetSize(amtrView.bomb, 38*wr, 38*hr);

	bombCounterFontSize = math.floor(10 * hr);


	--bombCounterFontSize = math.floor(10 * hr);

	
	local chargesOffsetY = -(27 * hr);
	local chargesOffsetX = 63 * wr;
	local chargesSize = 32 * wr;	
	local spacing = 19 * wr;

	-- 4 charges
	for i=0, 3 do
		local x = math.floor(chargesOffsetX + spacing*i + (spacing/2));
		amtr.setWidgetPos(amtrView.arcaneChargeIcons[i], x, chargesOffsetY);
		amtrView.arcaneChargeIcons[i].icon:SetPoint("TOPLEFT", 1*wr, -(0.5*hr));
		amtr.setWidgetSize(amtrView.arcaneChargeIcons[i], chargesSize, chargesSize);
	end

	local manaBarHeight = 15 * hr;
	local manaBarOffsetX = 4 * wr;
	local manaBarOffsetY = 4 * hr;

	amtrView.manaBar:SetPoint("TOPLEFT", "uiAmtrFrame", "TOPLEFT", manaBarOffsetX, 0 - manaBarOffsetY);
	amtrView.manaBar:SetPoint("BOTTOMRIGHT", "uiAmtrFrame", "TOPLEFT", width-manaBarOffsetX, -manaBarHeight);
	--widget:SetPoint("TOPLEFT", x, y);
	-- It's not clear that layoutView gets called when we re-enable the addon on spec changes etc.

	MyScriptOptionsButton:SetPoint("BOTTOMRIGHT", "uiAmtrFrame", "BOTTOMRIGHT", -(3 * wr), 9*hr);


	-- if using a spellName, GetSpellInfo only returns the info if the spell exists in our spell book.
	-- So we can use that to determine which bomb has been talented.
	if (powerTalentSpellName ~= nil) then
		local name, _, icon = GetSpellInfo(bombSpellName);
		amtrView.bomb.icon:SetTexture(icon);
	end

	if (powerTalentSpellName ~= nil) then
		local name, _, icon = GetSpellInfo(powerTalentSpellName);
		amtrView.powerTalent.icon:SetTexture(icon);
	end

end


-- Redraw the contents of the view with the data from the model.
function amtr.updateView()

	--local fontFlags = "OUTLINE";
	--local igniteFontSize = amtrConfig.fontSize;
	--local bombCounterFontSize = math.floor(amtrConfig.fontSize / 2.5); 
	--local critFontSize = math.floor(amtrConfig.fontSize / 2);

	-- Update bomb time left.
	if (amtr.bombRemaining > 0) then
		-- A bit costly to do every frame. Store local bombRemaining
		amtrView.bombCounter:Show();
		amtrView.bombCounter:SetFont(FONT, bombCounterFontSize, "THICKOUTLINE"); --, "THICKOUTLINE"
		amtrView.bombCounter:SetText( math.floor(amtr.bombRemaining) );
		amtrView.bombCounter:SetTextColor(1,1,1);
		amtr.setWidgetActive(amtrView.bomb, true);
	else
		--amtrView.bombCounter:SetText("X");
		amtrView.bombCounter:Hide();
		amtr.setWidgetActive(amtrView.bomb, false);
	end

	-- Update power talent buff remaining.
	if (amtr.powerTalentRemaining > 0) then
		-- A bit costly to do every frame. Store local bombRemaining
		amtrView.powerTalentCounter:Show();
		amtrView.powerTalentCounter:SetFont(FONT, bombCounterFontSize, "THICKOUTLINE"); --, "THICKOUTLINE"
		amtrView.powerTalentCounter:SetText( math.floor(amtr.powerTalentRemaining) );
		amtrView.powerTalentCounter:SetTextColor(1,1,1);
		amtr.setWidgetActive(amtrView.powerTalent, true);
	else
		--amtrView.bombCounter:SetText("X");
		amtrView.powerTalentCounter:Hide();
		amtr.setWidgetActive(amtrView.powerTalent, false);
	end

	
	-- Update Arcane Charges. Also a bit costly to do every frame for no reason.
	for i=0, 3 do
		amtr.setWidgetActive(amtrView.arcaneChargeIcons[i], i < amtr.arcaneCharges);
	end


	local mana = amtr.mana;
	local minMana = amtrConfig.minMana;
	if (minMana <= 100) then	-- User set mana using percentage. Convert to real fixed value.
		minMana = math.floor((minMana/100) * amtr.maxMana);
	end

	if (mana < minMana) then
		mana = minMana;
	elseif (mana > amtr.maxMana) then
		mana = amtr.maxMana;
	end

	amtrView.manaBar:SetMinMaxValues(minMana, amtr.maxMana);
	amtrView.manaBar:SetValue( mana );

end

function onResize(self, width, height)
	local w = amtrView.frame:GetWidth();
	local h = DEFAULT_HEIGHT * (w/DEFAULT_WIDTH);
	amtrView.frame:SetWidth( w );
	amtrView.frame:SetHeight( h );

	amtr.layoutView();
end